/*
# ---------------------------------------------------------------------
#
# Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image 
#                        pour la Santé)
# Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
#
#  This software is governed by the CeCILL-B license under French law and 
#  abiding by the rules of distribution of free software. You can  use, 
#  modify and/ or redistribute the software under the terms of the CeCILL-B 
#  license as circulated by CEA, CNRS and INRIA at the following URL 
#  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
#  or in the file LICENSE.txt.
#
#  As a counterpart to the access to the source code and  rights to copy,
#  modify and redistribute granted by the license, users are provided only
#  with a limited warranty  and the software's author,  the holder of the
#  economic rights,  and the successive licensors  have only  limited
#  liability. 
#
#  The fact that you are presently reading this means that you have had
#  knowledge of the CeCILL-B license and that you accept its terms.
# ------------------------------------------------------------------------  
*/

/*=========================================================================                                                                               
Program:   bbtkGEditor
Module:    $RCSfile$
Language:  C++
Date:      $Date$
Version:   $Revision$
=========================================================================*/

/* ---------------------------------------------------------------------

* Copyright (c) CREATIS-LRMN (Centre de Recherche en Imagerie Medicale)
* Authors : Eduardo Davila, Laurent Guigues, Jean-Pierre Roux, Ricardo A Corredor
*
*  This software is governed by the CeCILL-B license under French law and 
*  abiding by the rules of distribution of free software. You can  use, 
*  modify and/ or redistribute the software under the terms of the CeCILL-B 
*  license as circulated by CEA, CNRS and INRIA at the following URL 
*  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
*  or in the file LICENSE.txt.
*
*  As a counterpart to the access to the source code and  rights to copy,
*  modify and redistribute granted by the license, users are provided only
*  with a limited warranty  and the software's author,  the holder of the
*  economic rights,  and the successive licensors  have only  limited
*  liability. 
*
*  The fact that you are presently reading this means that you have had
*  knowledge of the CeCILL-B license and that you accept its terms.
* ------------------------------------------------------------------------ */                                                                         



/**
*  \file 
*  \brief Class bbtk::wxDiagramPropertiesEditionDialog
*/

/****
* BBTK GEditor Improvements - 2nd HackFest
* Ricardo A Corredor J Ricardo.Corredor@creatis.insa-lyon.fr
* RaC - 2012
****/

#ifndef __wxDiagramPropertiesEditionDialog_h__
#define __wxDiagramPropertiesEditionDialog_h__

//Includes same project
#include "bbtkwxGUIEditorGraphicBBS.h"
#include <bbtkUtilities.h>
#include "wxVtkSceneManager.h"

//Includes wxWidgets
#include <wx/wx.h>
#include <wx/aui/aui.h>
#include <wx/combobox.h>
#include <wx/treectrl.h>

//Includes creaMaracasVisu

//Includes std
#include <iostream>


namespace bbtk
{

	//RaC: It is important if it exists a double relation 
	//e.g. wxBlackBoxEditionDialog includes wxGUIEditorGraphicBBS, and wxGUIEditorGraphicBBS includes wxBlackBoxEditionDialog
	class wxGUIEditorGraphicBBS;
	//class wxVtkSceneManager;

	class wxDiagramPropertiesEditionDialog :  public wxDialog
	{
	public: 
		wxDiagramPropertiesEditionDialog(wxGUIEditorGraphicBBS *parent, NodeTreeC tree);
		~wxDiagramPropertiesEditionDialog();
		
		void constructBoxTree(NodeTreeC nodeTree, wxTreeItemId itemId); //CFT
		void constructDiagramPropertiesEditionDialog();

		void onClickOk(wxCommandEvent& event);
		void onClickClose(wxCommandEvent& event);
		void OnComboBoxSelected(wxCommandEvent& event);
		
	private:
		wxAuiManager *_dialogAUIMgr;
		wxPanel *_panel;
		wxGUIEditorGraphicBBS *_parent;
		wxTextCtrl *_txtAuthor;
		wxTextCtrl *_txtCategory;
		wxTextCtrl *_txtDescription;
		wxComboBox *_diagramType;
		wxComboBox *_diagramMessageKind;
		wxComboBox *_diagramMessageLevel;
		wxTreeCtrl *_treeBox;
		NodeTreeC _tree;
	protected:

	};


}
// namespace bbtk
#endif

